100 hue=240 : REMark Hue angle 0 to 360 degrees
110 :
120 input$='RAM1_b_pic'
130 output$='ram1_out_pic'
140 :
150 REMark Hue-RGB conversion parameters
160 hue_r=RAD(hue)
170 t0=COS(hue_r)+(1-COS(hue_r))/3
180 t1=(1-COS(hue_r))/3-SQRT(1/3)*SIN(hue_r)
190 t2=(1-COS(hue_r))/3+SQRT(1/3)*SIN(hue_r)
200 :
210 f%=16384 : REMark factor to convert float to integer
220 DIM arr%(2,2) : REMark conversion matrix
230 arr%(0,0)=f%*t0 : arr%(0,1)=f%*t1 : arr%(0,2)=f%*t2
240 arr%(1,0)=f%*t2 : arr%(1,1)=f%*t0 : arr%(1,2)=f%*t1
250 arr%(2,0)=f%*t1 : arr%(2,1)=f%*t2 : arr%(2,2)=f%*t0
260 :
270 DELETE output$
280 ERT FPIC_RGBMATRIX(input$,output$,arr%)
290 REMark EX Photon,output$
300 :
310 REMark ------------------------------------------
320 REMark Hue angle 0-60   Red to Yellow
330 REMark          60-120  Yellow to Green
340 REMark         120-180  Green to Cyan
350 REMark         180-240  Cyan to Blue
360 REMark         240-300  Blue to Magenta
370 REMark         300-360  Magenta to Red
380 REMark
390 REMark Procedure below will show Hue colour chart
410 REMark ------------------------------------------
420 :
430 DEFine PROCedure Huechart
435 COLOUR_NATIVE
440 i%=3 : s%=30 : p%=0 : r%=255 : b%=0 : t%=256/6/i%
450 ch%=FOPEN('scr') : WINDOW#ch%;256/i%*6+20,s%+10,2,1 : CLS#ch%
460 FOR n%=0 TO 6 : PRINT#ch%; TO t%*n%;(n%*60)&CHR$(186);
470 FOR g%=0 TO 255 STEP  i% : BLOCK#ch%;1,s%,p%,10,MODE_RGB%(r%,g%,b%) : p%=p%+1
480 FOR r%=255 TO 0 STEP -i% : BLOCK#ch%;1,s%,p%,10,MODE_RGB%(r%,g%,b%) : p%=p%+1
490 FOR b%=0 TO 255 STEP  i% : BLOCK#ch%;1,s%,p%,10,MODE_RGB%(r%,g%,b%) : p%=p%+1
500 FOR g%=255 TO 0 STEP -i% : BLOCK#ch%;1,s%,p%,10,MODE_RGB%(r%,g%,b%) : p%=p%+1
510 FOR r%=0 TO 255 STEP  i% : BLOCK#ch%;1,s%,p%,10,MODE_RGB%(r%,g%,b%) : p%=p%+1
520 FOR b%=255 TO 0 STEP -i% : BLOCK#ch%;1,s%,p%,10,MODE_RGB%(r%,g%,b%) : p%=p%+1
530 CLOSE#ch%
540 END DEFine
